**Overview**

Translation files are assumed to be correctly formatted UTF-8 files.
Only key-value pairs are allowed, nested values will not work.

The game will perform substitutions for fields that are in brackets, like so:
```
Ruled by [name]
```

The game logic needs to be updated to add new substitutions, for example `[firstName]`.

The game logic also needs to be updated to handle new languages being added, see `i18n.as`.
Updated the properties `languageMap` and `locales` to help map against what AIR reports to what the game is bundled with. 


**Scripts**

There are two scripts to help with translations: `check-keys.js` and `rebuild-keys.js`. 
They are meant to be run from the command line with `node` (any version should do, and no extra packages are needed).

Run `node check-keys.js` to sanity check that all keys are present in all translation keys.
It will give you an overview of number of lines, key counts and if there are any differences in keys against `en_US.json`.


If there are differences, and particularly _extra keys_ in the translation you should attempt to fix them manually.


Run `node rebuild-keys.js` to fix all problems with translation files. This uses `en_US.json` as a template and attempts
to re-create the translations files with the exact same whitespace and key-order as `en_US.json`.
Make sure the files are committed before you run this so you can see the diff.

Values for keys that exists in the translation file will remain. 

Any extra keys present in the translation file will be removed. 

Any missing keys will be added and filled with the value from `en_US.json`.  

